<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.17.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Utilities &mdash; Heiwa  documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
      <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/jquery.js"></script>
        <script src="_static/underscore.js"></script>
        <script src="_static/doctools.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="prev" title="Users" href="heiwa.views.user.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="index.html" class="icon icon-home"> Heiwa
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="performance.html">Performance</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="heiwa.html">API Documentation</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="heiwa.html#subpackages">Subpackages</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="heiwa.authentication.html">Authentication</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.constants.html">Statuses</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.database.html">Database</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.json_ld.html">JSON-LD</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.enums.html">Enums</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.error_handlers.html">Error handlers</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.exceptions.html">Exceptions</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.limiter.html">Rate limiter</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.tasks.html">Tasks</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.types.html">Abstract types</a></li>
<li class="toctree-l3"><a class="reference internal" href="heiwa.validators.html">Validators</a></li>
<li class="toctree-l3 current"><a class="reference internal" href="heiwa.views.html">API views</a><ul class="current">
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.category.html">Categories</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.file.html">Files</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.forum.html">Forums</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.group.html">Groups</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.guest.html">Guests</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.message.html">Messages</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.meta.html">Meta information</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.notification.html">Notifications</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.oidc.html">OIDC</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.post.html">Posts</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.statistic.html">Statistics</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.thread.html">Threads</a></li>
<li class="toctree-l4"><a class="reference internal" href="heiwa.views.user.html">Users</a></li>
<li class="toctree-l4 current"><a class="current reference internal" href="#">Utilities</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="heiwa.html#module-heiwa">Root</a></li>
</ul>
</li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">Heiwa</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="heiwa.html">API Documentation</a> &raquo;</li>
          <li><a href="heiwa.views.html">API views</a> &raquo;</li>
      <li>Utilities</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/heiwa.views.utils.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="module-heiwa.views.utils">
<span id="utilities"></span><h1>Utilities<a class="headerlink" href="#module-heiwa.views.utils" title="Permalink to this headline"></a></h1>
<p>Utilities for API views.</p>
<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.get_category">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">get_category</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="heiwa.database.html#heiwa.database.Category" title="heiwa.database.category.Category"><span class="pre">heiwa.database.category.Category</span></a></span></span><a class="reference internal" href="_modules/heiwa/views/utils/get_and_validate.html#get_category"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.get_category" title="Permalink to this definition"></a></dt>
<dd><p>Gets the <a class="reference internal" href="heiwa.database.html#heiwa.database.Category" title="heiwa.database.Category"><code class="xref py py-class docutils literal notranslate"><span class="pre">Category</span></code></a> with the given
<code class="docutils literal notranslate"><span class="pre">id_</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Category.id" title="heiwa.database.Category.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the category to
find.</p></li>
<li><p><strong>session</strong> – The session to find the category with. Defaults to
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> who must have permission
to view the category. Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APICategoryNotFound" title="heiwa.exceptions.APICategoryNotFound"><strong>heiwa.exceptions.APICategoryNotFound</strong></a> – Raised when the category doesn’t
exist, or the user does not have permission to view it.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The category.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.get_forum">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">get_forum</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="heiwa.database.html#heiwa.database.Forum" title="heiwa.database.forum.Forum"><span class="pre">heiwa.database.forum.Forum</span></a></span></span><a class="reference internal" href="_modules/heiwa/views/utils/get_and_validate.html#get_forum"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.get_forum" title="Permalink to this definition"></a></dt>
<dd><p>Gets the <a class="reference internal" href="heiwa.database.html#heiwa.database.Forum" title="heiwa.database.Forum"><code class="xref py py-class docutils literal notranslate"><span class="pre">Forum</span></code></a> with the given <code class="docutils literal notranslate"><span class="pre">id_</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Forum.id" title="heiwa.database.Forum.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the forum to find.</p></li>
<li><p><strong>session</strong> – The session to find the forum with. Defaults to
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> who must have permission
to view the forum. Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIForumNotFound" title="heiwa.exceptions.APIForumNotFound"><strong>heiwa.exceptions.APIForumNotFound</strong></a> – Raised when the forum doesn’t
exist, or the user does not have permission to view it.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The forum.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.get_group">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">get_group</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="heiwa.database.html#heiwa.database.Group" title="heiwa.database.group.Group"><span class="pre">heiwa.database.group.Group</span></a></span></span><a class="reference internal" href="_modules/heiwa/views/utils/get_and_validate.html#get_group"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.get_group" title="Permalink to this definition"></a></dt>
<dd><p>Gets the <a class="reference internal" href="heiwa.database.html#heiwa.database.Group" title="heiwa.database.Group"><code class="xref py py-class docutils literal notranslate"><span class="pre">Group</span></code></a> with the given <code class="docutils literal notranslate"><span class="pre">id_</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Group.id" title="heiwa.database.Group.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the group to find.</p></li>
<li><p><strong>session</strong> – The session to find the group with. Defaults to
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> who must have permission
to view the group. Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIGroupNotFound" title="heiwa.exceptions.APIGroupNotFound"><strong>heiwa.exceptions.APIGroupNotFound</strong></a> – Raised when the group doesn’t
exist, or the user does not have permission to view it.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The group.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.get_identifier_hash">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">get_identifier_hash</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">str</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/hash.html#get_identifier_hash"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.get_identifier_hash" title="Permalink to this definition"></a></dt>
<dd><p>Generates a base64-encoded Argon2id hash for the current
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.identifier</span></code>, with the current app’s <code class="docutils literal notranslate"><span class="pre">IDENTIFIER_HASH_PEPPER</span></code>
config key as the salt (pepper).</p>
<p>Since hashes will always be Argon2id and share the same parameters, to save
storage, extra data usually present is not included and only the raw hash is
returned.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The hash.</p>
</dd>
</dl>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>A shared pepper isn’t the best from a security standpoint, but the best we
can afford to use here, since this function is primarily used to find
existing rows based on the hash’s result - for example, guests with the
same IP address. For this to happen at a reasonable speed, salt values
random for each user cannot be used.</p>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>To avoid leaking the secret key, the pepper is separate.</p>
</div>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference external" href="https://wikiless.org/ wiki/Pepper_(cryptography)">Wikipedia - Pepper (cryptography), on Wikiless</a></p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.get_order_by_expression">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">get_order_by_expression</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">model</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">sqlalchemy.orm.decl_api.DeclarativeMeta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nulls_last</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">True</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">sqlalchemy.sql.elements.UnaryExpression</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/search.html#get_order_by_expression"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.get_order_by_expression" title="Permalink to this definition"></a></dt>
<dd><p>Generates an expression from the <code class="docutils literal notranslate"><span class="pre">order</span></code> key in a JSON request body which
other queries can use to order their results. Contains the <code class="docutils literal notranslate"><span class="pre">NULLS</span> <span class="pre">LAST</span></code>
modifier by default. This function must be run inside a Flask request context.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>model</strong> – The model, one of whose columns should be used for ordering.</p></li>
<li><p><strong>nulls_last</strong> – Whether or not <code class="docutils literal notranslate"><span class="pre">NULL</span></code> values should be last. <code class="xref py py-data docutils literal notranslate"><span class="pre">True</span></code>
by default.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The expression.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.get_search_schema">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">get_search_schema</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">allowed_order_attrs</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Iterable</span><span class="p"><span class="pre">[</span></span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span></em>, <em class="sig-param"><span class="n"><span class="pre">use_filter</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">bool</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">default_order_by</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">default_order_asc</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">bool</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">limit_max</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">offset_max</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">blueprint_name</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Dict</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/schema.html#get_search_schema"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.get_search_schema" title="Permalink to this definition"></a></dt>
<dd><p>Generates a Cerberus schema used for validating input to endpoints using
search functions. These can, for example, be <code class="docutils literal notranslate"><span class="pre">list_</span></code>, <code class="docutils literal notranslate"><span class="pre">mass_edit</span></code> and
<code class="docutils literal notranslate"><span class="pre">mass_delete</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>allowed_order_attrs</strong> – The model attributes a user can order the
results by.</p></li>
<li><p><strong>use_filter</strong> – Whether or not to include a validator for <code class="docutils literal notranslate"><span class="pre">filter</span></code>.
This is used for filtering out different results and supports a wide
range of conditions, operators and recursion. <code class="xref py py-data docutils literal notranslate"><span class="pre">True</span></code> by default.</p></li>
<li><p><strong>default_order_by</strong> – The attribute to order by by default. If left as
<code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, the user will have to specify an attribute in each request.</p></li>
<li><p><strong>default_order_asc</strong> – Whether or not the order will be ascending by
default. If left as <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, the user will have to specify this in
each request.</p></li>
<li><p><strong>limit_max</strong> – The maximum number of results. If left as <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code> and
the provided <code class="docutils literal notranslate"><span class="pre">blueprint_name</span></code> is in the <code class="docutils literal notranslate"><span class="pre">LIMIT_MAX_SPECIFIC</span></code> config
key, it’s set to its max limit. If it’s not present, this value is set to
the <code class="docutils literal notranslate"><span class="pre">LIMIT_MAX_DEFAULT</span></code> config key.</p></li>
<li><p><strong>offset_max</strong> – The maximum offset. If left as <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code> and the
provided <code class="docutils literal notranslate"><span class="pre">blueprint_name</span></code> is in the <code class="docutils literal notranslate"><span class="pre">OFFSET_MAX_SPECIFIC</span></code> config key,
it’s set to its max offset. If it’s not present, this value is set to the
<code class="docutils literal notranslate"><span class="pre">OFFSET_MAX_DEFAULT</span></code> config key.</p></li>
<li><p><strong>blueprint_name</strong> – The current Flask
<code class="xref py py-class docutils literal notranslate"><span class="pre">Blueprint</span></code>’s <code class="xref py py-attr docutils literal notranslate"><span class="pre">name</span></code>.
This is used for fetching default <code class="docutils literal notranslate"><span class="pre">limit_max</span></code> and <code class="docutils literal notranslate"><span class="pre">offset_max</span></code> values,
when they’re unset. <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code> by default.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The generated schema.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.get_search_schema_filter_in_max_list_length">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">get_search_schema_filter_in_max_list_length</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">blueprint_name</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">int</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/schema.html#get_search_schema_filter_in_max_list_length"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.get_search_schema_filter_in_max_list_length" title="Permalink to this definition"></a></dt>
<dd><p>Gets the maximum length of lists contained within the <code class="docutils literal notranslate"><span class="pre">$in</span></code> search
filtering schema. If <code class="docutils literal notranslate"><span class="pre">blueprint_name</span></code> is left as <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, the value
returned is the <code class="docutils literal notranslate"><span class="pre">SEARCH_MAX_IN_LIST_LENGTH_DEFAULT</span></code> config key. If not,
the value can also be its entry in <code class="docutils literal notranslate"><span class="pre">SEARCH_MAX_IN_LIST_LENGTH_SPECIFIC</span></code>,
if it has one.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>blueprint_name</strong> – The current Flask
<code class="xref py py-class docutils literal notranslate"><span class="pre">Blueprint</span></code>’s <code class="xref py py-attr docutils literal notranslate"><span class="pre">name</span></code>.</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The maximum <code class="docutils literal notranslate"><span class="pre">$in</span></code> list length.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.get_search_schema_filter_registry">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">get_search_schema_filter_registry</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">rules</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Dict</span><span class="p"><span class="pre">[</span></span><span class="pre">str</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Dict</span><span class="p"><span class="pre">[</span></span><span class="pre">str</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">Dict</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Any</span><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">]</span></span></span></em>, <em class="sig-param"><span class="n"><span class="pre">schema_name</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">'search_filter'</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">cerberus.schema.SchemaRegistry</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/schema.html#get_search_schema_filter_registry"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.get_search_schema_filter_registry" title="Permalink to this definition"></a></dt>
<dd><p>Generates a registry for use by the <code class="docutils literal notranslate"><span class="pre">filter</span></code> key in search schemas.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>rules</strong> – All additional rules</p></li>
<li><p><strong>schema_name</strong> – The name of the schema. Uses a sensisble <code class="docutils literal notranslate"><span class="pre">search_filter</span></code>
default.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The schema.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.get_session_and_user_defaults">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">get_session_and_user_defaults</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Tuple</span><span class="p"><span class="pre">[</span></span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/get_and_validate.html#get_session_and_user_defaults"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.get_session_and_user_defaults" title="Permalink to this definition"></a></dt>
<dd><p>If <code class="docutils literal notranslate"><span class="pre">session</span></code> is <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, sets it to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code>, the
standard global session variable. The same happens with <code class="docutils literal notranslate"><span class="pre">user</span></code> and
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code>.</p>
<p><strong>While not forbidden, this function is only meant to be used as a shortcut
in this module’s functions and other similar ones. It is not to be used on
its own</strong></p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>session</strong> – The current SQLAlchemy session.</p></li>
<li><p><strong>user</strong> – The current user.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.get_thread">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">get_thread</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="heiwa.database.html#heiwa.database.Thread" title="heiwa.database.thread.Thread"><span class="pre">heiwa.database.thread.Thread</span></a></span></span><a class="reference internal" href="_modules/heiwa/views/utils/get_and_validate.html#get_thread"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.get_thread" title="Permalink to this definition"></a></dt>
<dd><p>Gets the <a class="reference internal" href="heiwa.database.html#heiwa.database.Thread" title="heiwa.database.Thread"><code class="xref py py-class docutils literal notranslate"><span class="pre">Thread</span></code></a> with the given <code class="docutils literal notranslate"><span class="pre">id_</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Thread.id" title="heiwa.database.Thread.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the thread to find.</p></li>
<li><p><strong>session</strong> – The session to find the thread with. Defaults to
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> who must have permission
to view the thread. Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIThreadNotFound" title="heiwa.exceptions.APIThreadNotFound"><strong>heiwa.exceptions.APIThreadNotFound</strong></a> – Raised when the thread doesn’t
exist, or the user does not have permission to view it.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The thread.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.get_user">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">get_user</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a></span></span><a class="reference internal" href="_modules/heiwa/views/utils/get_and_validate.html#get_user"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.get_user" title="Permalink to this definition"></a></dt>
<dd><p>Gets the <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> with the given <code class="docutils literal notranslate"><span class="pre">id_</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User.id" title="heiwa.database.User.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the user to find.</p></li>
<li><p><strong>session</strong> – The session to find the user with. Defaults to
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The user who must have permission to view the requested user.
Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIUserNotFound" title="heiwa.exceptions.APIUserNotFound"><strong>heiwa.exceptions.APIUserNotFound</strong></a> – Raised when the requested user
doesn’t exist, or <code class="docutils literal notranslate"><span class="pre">user</span></code> lacks the permission to view them.</p>
</dd>
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>The user.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.get_user_jwt">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">get_user_jwt</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">user_id</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">name</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">str</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">expires_after</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">int</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">str</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/jwt.html#get_user_jwt"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.get_user_jwt" title="Permalink to this definition"></a></dt>
<dd><p>Creates a JWT for the <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> with the given
<code class="docutils literal notranslate"><span class="pre">user_id</span></code>.</p>
<p>It’s assumed that the user exists, since there’s no need to look for data
about them stored in the database. An invalid JWT will be generated if the
input is invalid, no exceptions will be raised.</p>
<p>To avoid (admittedly very unlikely) collisions with other views using
JWTs, the <code class="docutils literal notranslate"><span class="pre">sub</span></code> claim is prepended with the
<a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> class name and <code class="docutils literal notranslate"><span class="pre">:</span></code>. This string is
referred to as the <strong>resource type</strong>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>user_id</strong> – The user’s <a class="reference internal" href="heiwa.database.html#heiwa.database.User.id" title="heiwa.database.User.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a>.</p></li>
<li><p><strong>name</strong> – The name of the service which generated the JWT. If left as
<code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, this will be the <code class="docutils literal notranslate"><span class="pre">META_NAME</span></code> key in the current app’s
config.</p></li>
<li><p><strong>expires_after</strong> – How much time until the JWT expires. If left as
<code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>, this will be the <code class="docutils literal notranslate"><span class="pre">USER_JWT_EXPIRES_AFTER</span></code> key in the
current app’s config. To comply with the JWT specification, this is not
an ISO datetime, but a UNIX timestamp.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>An encoded version of the JWT, signed using the current app’s
<code class="docutils literal notranslate"><span class="pre">USER_JWT_SECRET_KEY</span></code>.</p>
</dd>
</dl>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference external" href="https://datatracker.ietf.org/doc/html/rfc7519">RFC 7519 - JSON web token</a></p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.handle_edit">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">handle_edit</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">object_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="heiwa.database.utils.html#heiwa.database.utils.PermissionControlMixin" title="heiwa.database.utils.mixins.PermissionControlMixin"><span class="pre">heiwa.database.utils.mixins.PermissionControlMixin</span></a></span></em>, <em class="sig-param"><span class="n"><span class="pre">values</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Dict</span><span class="p"><span class="pre">[</span></span><span class="pre">str</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Any</span><span class="p"><span class="pre">]</span></span></span></em>, <em class="sig-param"><span class="n"><span class="pre">exception</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Exception</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">current_utc_time</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">datetime.datetime</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/edit.html#handle_edit"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.handle_edit" title="Permalink to this definition"></a></dt>
<dd><p>Updates the attributes of <code class="docutils literal notranslate"><span class="pre">object_</span></code> as <code class="docutils literal notranslate"><span class="pre">values</span></code> describes and checks
if any of them are different than the previous ones. If not, <code class="docutils literal notranslate"><span class="pre">exception</span></code>
is raised. Otherwise, the object’s
<code class="xref py py-meth docutils literal notranslate"><span class="pre">edited</span></code> method is
called.</p>
<p>This function is only meant to be used in <code class="docutils literal notranslate"><span class="pre">edit</span></code> endpoints, where repeating
the same code is unnecessary.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>object</strong> – The object to edit. Since the fact it’s been edited is also
going to be handled, this must be a subclass of
<a class="reference internal" href="heiwa.database.utils.html#heiwa.database.utils.PermissionControlMixin" title="heiwa.database.utils.PermissionControlMixin"><code class="xref py py-class docutils literal notranslate"><span class="pre">heiwa.database.utils.PermissionControlMixin</span></code></a>.</p></li>
<li><p><strong>values</strong> – The values to update the object with.</p></li>
<li><p><strong>exception</strong> – The exception to be called when there aren’t any changes.</p></li>
<li><p><strong>current_utc_time</strong> – The current date and time, in the UTC timezone. This
is to be used when the
<code class="xref py py-meth docutils literal notranslate"><span class="pre">edited</span></code> method
is called, but can be left as <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.parse_search">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">parse_search</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">conditions</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Dict</span><span class="p"><span class="pre">[</span></span><span class="pre">str</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">Dict</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">Any</span><span class="p"><span class="pre">]</span></span><span class="p"><span class="pre">]</span></span></span></em>, <em class="sig-param"><span class="n"><span class="pre">model</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="heiwa.database.html#heiwa.database.Base" title="sqlalchemy.orm.decl_api.Base"><span class="pre">sqlalchemy.orm.decl_api.Base</span></a></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">sqlalchemy.sql.elements.BinaryExpression</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.sql.elements.ClauseList</span><span class="p"><span class="pre">]</span></span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/search.html#parse_search"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.parse_search" title="Permalink to this definition"></a></dt>
<dd><p>Converts the given dictionary formatted conditions, ones seen in different
API endpoints’ <code class="docutils literal notranslate"><span class="pre">filter</span></code> keys, to SQLAlchemy ones. The conditions are
presumed to have already been validated using Cerberus and no extra checks
are performed.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>conditions</strong> – The conditions.</p></li>
<li><p><strong>model</strong> – The model to use the given conditions on.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>SQLAlchemy conditions.</p>
</dd>
</dl>
<dl>
<dt>Example:</dt><dd><div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="p">{</span>
        <span class="s2">&quot;$and&quot;</span><span class="p">:</span> <span class="p">[</span>
                <span class="p">{</span><span class="s2">&quot;$greater_than&quot;</span><span class="p">:</span> <span class="p">{</span><span class="s2">&quot;post_count&quot;</span><span class="p">:</span> <span class="mi">1000</span><span class="p">}},</span>
                <span class="p">{</span><span class="s2">&quot;$or&quot;</span><span class="p">:</span> <span class="p">[</span>
                        <span class="p">{</span><span class="s2">&quot;$equals&quot;</span><span class="p">:</span> <span class="p">{</span><span class="s2">&quot;user_id&quot;</span><span class="p">:</span> <span class="s2">&quot;UUID_HERE&quot;</span><span class="p">}},</span>
                        <span class="p">{</span><span class="s2">&quot;$equals&quot;</span><span class="p">:</span> <span class="p">{</span><span class="s2">&quot;user_id&quot;</span><span class="p">:</span> <span class="s2">&quot;UUID_HERE&quot;</span><span class="p">}}</span>
                <span class="p">]}</span>
        <span class="p">]</span>
<span class="p">}</span>
</pre></div>
</div>
<p>Is converted to:</p>
<div class="highlight-sql notranslate"><div class="highlight"><pre><span></span><span class="n">post_count</span><span class="w"> </span><span class="o">&gt;</span><span class="w"> </span><span class="mi">1000</span><span class="w"> </span><span class="k">AND</span><span class="w"> </span><span class="p">(</span><span class="n">user_id</span><span class="w"> </span><span class="o">=</span><span class="w"> </span><span class="n">UUID_HERE</span><span class="w"> </span><span class="k">OR</span><span class="w"> </span><span class="n">user_id</span><span class="w"> </span><span class="o">=</span><span class="w"> </span><span class="n">UUID_HERE</span><span class="p">)</span><span class="w"></span>
</pre></div>
</div>
</dd>
</dl>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><code class="xref py py-const docutils literal notranslate"><span class="pre">OPERATORS</span></code></p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.requires_permission">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">requires_permission</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">action</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">resource</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">sqlalchemy.orm.decl_api.DeclarativeMeta</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.Base" title="sqlalchemy.orm.decl_api.Base"><span class="pre">sqlalchemy.orm.decl_api.Base</span></a><span class="p"><span class="pre">]</span></span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">Callable</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/permissions.html#requires_permission"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.requires_permission" title="Permalink to this definition"></a></dt>
<dd><p>A wrapper that checks whether or not the current <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> has
permission to perform <code class="docutils literal notranslate"><span class="pre">action</span></code> on the given <code class="docutils literal notranslate"><span class="pre">resource</span></code>. If not, an
exception is raised.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>action</strong> – The action.</p></li>
<li><p><strong>resource</strong> – The resource the action should be performed on. If this is
not an instance of a model, but only a model, the decision is based on
its <code class="docutils literal notranslate"><span class="pre">static_actions</span></code> attribute. Otherwise, the decision is based on
<code class="docutils literal notranslate"><span class="pre">instance_actions</span></code>.</p></li>
<li><p><strong>kwargs</strong> – Keyword arguments to be passed to the underlying function.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APINoPermission" title="heiwa.exceptions.APINoPermission"><strong>heiwa.exceptions.APINoPermission</strong></a> – Raised when the user does not have
permission to perform said action. The resource name, as well as the action
are included in its
<code class="xref py py-attr docutils literal notranslate"><span class="pre">details</span></code>.</p>
</dd>
</dl>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="heiwa.database.utils.html#heiwa.database.utils.PermissionControlMixin" title="heiwa.database.utils.PermissionControlMixin"><code class="xref py py-class docutils literal notranslate"><span class="pre">PermissionControlMixin</span></code></a></p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.validate_category_exists">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">validate_category_exists</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/get_and_validate.html#validate_category_exists"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.validate_category_exists" title="Permalink to this definition"></a></dt>
<dd><p>Validates that the <a class="reference internal" href="heiwa.database.html#heiwa.database.Category" title="heiwa.database.Category"><code class="xref py py-class docutils literal notranslate"><span class="pre">Category</span></code></a> with the
given <code class="docutils literal notranslate"><span class="pre">id_</span></code> exists.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Category.id" title="heiwa.database.Category.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the category to
find.</p></li>
<li><p><strong>session</strong> – The session to find the category with. Defaults to
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> who must have permission
to view the category. Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APICategoryNotFound" title="heiwa.exceptions.APICategoryNotFound"><strong>heiwa.exceptions.APICategoryNotFound</strong></a> – Raised when the category doesn’t
exist, or the user does not have permission to view it.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.validate_forum_exists">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">validate_forum_exists</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/get_and_validate.html#validate_forum_exists"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.validate_forum_exists" title="Permalink to this definition"></a></dt>
<dd><p>Validates that the <a class="reference internal" href="heiwa.database.html#heiwa.database.Forum" title="heiwa.database.Forum"><code class="xref py py-class docutils literal notranslate"><span class="pre">Forum</span></code></a> with the given
ID exists.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Forum.id" title="heiwa.database.Forum.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the forum to find.</p></li>
<li><p><strong>session</strong> – The session to find the forum with. Defaults to
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> who must have permission
to view the forum. Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIForumNotFound" title="heiwa.exceptions.APIForumNotFound"><strong>heiwa.exceptions.APIForumNotFound</strong></a> – Raised when the forum doesn’t
exist, or the user does not have permission to view it.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.validate_group_exists">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">validate_group_exists</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/get_and_validate.html#validate_group_exists"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.validate_group_exists" title="Permalink to this definition"></a></dt>
<dd><p>Validates that the <a class="reference internal" href="heiwa.database.html#heiwa.database.Group" title="heiwa.database.Group"><code class="xref py py-class docutils literal notranslate"><span class="pre">Group</span></code></a> with the given
ID exists.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Group.id" title="heiwa.database.Group.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the group to find.</p></li>
<li><p><strong>session</strong> – The session to find the group with. Defaults to
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> who must have permission
to view the group. Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIGroupNotFound" title="heiwa.exceptions.APIGroupNotFound"><strong>heiwa.exceptions.APIGroupNotFound</strong></a> – Raised when the group doesn’t
exist, or the user does not have permission to view it.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.validate_permission">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">validate_permission</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a></span></em>, <em class="sig-param"><span class="n"><span class="pre">action</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">resource</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">sqlalchemy.orm.decl_api.DeclarativeMeta</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.Base" title="sqlalchemy.orm.decl_api.Base"><span class="pre">sqlalchemy.orm.decl_api.Base</span></a><span class="p"><span class="pre">]</span></span></span></em>, <em class="sig-param"><span class="o"><span class="pre">**</span></span><span class="n"><span class="pre">kwargs</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/permissions.html#validate_permission"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.validate_permission" title="Permalink to this definition"></a></dt>
<dd><p>Checks whether or not <code class="docutils literal notranslate"><span class="pre">user</span></code> has permission to perform <code class="docutils literal notranslate"><span class="pre">action</span></code> on the
given <code class="docutils literal notranslate"><span class="pre">resource</span></code>. If not, an exception is raised.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>action</strong> – The action.</p></li>
<li><p><strong>resource</strong> – The resource the action should be performed on. If this is
not an instance of a model, but only a model, the decision is based on
its <code class="docutils literal notranslate"><span class="pre">static_actions</span></code> attribute. Otherwise, the decision is based on
<code class="docutils literal notranslate"><span class="pre">instance_actions</span></code>.</p></li>
<li><p><strong>kwargs</strong> – Keyword arguments to be passed to the underlying function.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APINoPermission" title="heiwa.exceptions.APINoPermission"><strong>heiwa.exceptions.APINoPermission</strong></a> – Raised when the user does not have
permission to perform said action. The resource name, as well as the action
are included in its
<code class="xref py py-attr docutils literal notranslate"><span class="pre">details</span></code>.</p>
</dd>
</dl>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="heiwa.database.utils.html#heiwa.database.utils.PermissionControlMixin" title="heiwa.database.utils.PermissionControlMixin"><code class="xref py py-class docutils literal notranslate"><span class="pre">PermissionControlMixin</span></code></a></p>
</div>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.validate_thread_exists">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">validate_thread_exists</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/get_and_validate.html#validate_thread_exists"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.validate_thread_exists" title="Permalink to this definition"></a></dt>
<dd><p>Validates that the <a class="reference internal" href="heiwa.database.html#heiwa.database.Thread" title="heiwa.database.Thread"><code class="xref py py-class docutils literal notranslate"><span class="pre">Thread</span></code></a> with the given
ID exists.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.Thread.id" title="heiwa.database.Thread.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the thread to find.</p></li>
<li><p><strong>session</strong> – The session to find the thread with. Defaults to
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> who must have permission
to view the thread. Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIThreadNotFound" title="heiwa.exceptions.APIThreadNotFound"><strong>heiwa.exceptions.APIThreadNotFound</strong></a> – Raised when the thread doesn’t
exist, or the user does not have permission to view it.</p>
</dd>
</dl>
</dd></dl>

<dl class="py function">
<dt class="sig sig-object py" id="heiwa.views.utils.validate_user_exists">
<span class="sig-prename descclassname"><span class="pre">heiwa.views.utils.</span></span><span class="sig-name descname"><span class="pre">validate_user_exists</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">id_</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">uuid.UUID</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">session</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><span class="pre">sqlalchemy.orm.session.Session</span><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">user</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">Union</span><span class="p"><span class="pre">[</span></span><span class="pre">None</span><span class="p"><span class="pre">,</span></span><span class="w"> </span><a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.user.User"><span class="pre">heiwa.database.user.User</span></a><span class="p"><span class="pre">]</span></span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span> <span class="sig-return"><span class="sig-return-icon">&#x2192;</span> <span class="sig-return-typehint"><span class="pre">None</span></span></span><a class="reference internal" href="_modules/heiwa/views/utils/get_and_validate.html#validate_user_exists"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#heiwa.views.utils.validate_user_exists" title="Permalink to this definition"></a></dt>
<dd><p>Validates that the <a class="reference internal" href="heiwa.database.html#heiwa.database.User" title="heiwa.database.User"><code class="xref py py-class docutils literal notranslate"><span class="pre">User</span></code></a> with the given
<code class="docutils literal notranslate"><span class="pre">id_</span></code> exists.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>id</strong> – The <a class="reference internal" href="heiwa.database.html#heiwa.database.User.id" title="heiwa.database.User.id"><code class="xref py py-attr docutils literal notranslate"><span class="pre">id</span></code></a> of the user to find.</p></li>
<li><p><strong>session</strong> – The session to find the user with. Defaults to
<code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.sa_session</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
<li><p><strong>user</strong> – The user who must have permission to view the requested user.
Defaults to <code class="xref py py-attr docutils literal notranslate"><span class="pre">flask.g.user</span></code> if <code class="xref py py-data docutils literal notranslate"><span class="pre">None</span></code>.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><a class="reference internal" href="heiwa.exceptions.html#heiwa.exceptions.APIUserNotFound" title="heiwa.exceptions.APIUserNotFound"><strong>heiwa.exceptions.APIUserNotFound</strong></a> – Raised when the requested user
doesn’t exist, or <code class="docutils literal notranslate"><span class="pre">user</span></code> lacks the permission to view them.</p>
</dd>
</dl>
</dd></dl>

</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="heiwa.views.user.html" class="btn btn-neutral float-left" title="Users" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p></p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>